from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Boolean, Int

Samtools_Addreplacerg_V0_1_0 = CommandToolBuilder(tool="samtools_addreplacerg", base_command=["samtools", "addreplacerg"], inputs=[ToolInput(tag="in_set_mode_orphanonly", input_type=String(optional=True), prefix="-m", doc=InputDocumentation(doc="Set the mode of operation from one of overwrite_all, orphan_only [overwrite_all]")), ToolInput(tag="in_where_write_output", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Where to write output to [stdout]")), ToolInput(tag="in_rg_line_text", input_type=String(optional=True), prefix="-r", doc=InputDocumentation(doc="@RG line text")), ToolInput(tag="in_id_rg_use", input_type=String(optional=True), prefix="-R", doc=InputDocumentation(doc="ID of @RG line in existing header to use")), ToolInput(tag="in_output_uncompressed_data", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="Output uncompressed data")), ToolInput(tag="in_no_pg", input_type=Boolean(optional=True), prefix="--no-PG", doc=InputDocumentation(doc="Do not add a PG line")), ToolInput(tag="in_input_fmt", input_type=String(optional=True), prefix="--input-fmt", doc=InputDocumentation(doc="[,OPT[=VAL]]...\nSpecify input format (SAM, BAM, CRAM)")), ToolInput(tag="in_input_fmt_option", input_type=File(optional=True), prefix="--input-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single input file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_output_fmt", input_type=String(optional=True), prefix="--output-fmt", doc=InputDocumentation(doc="[,OPT[=VAL]]...\nSpecify output format (SAM, BAM, CRAM)")), ToolInput(tag="in_output_fmt_option", input_type=File(optional=True), prefix="--output-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference sequence FASTA FILE [null]")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of additional threads to use [0]")), ToolInput(tag="in_write_index", input_type=Boolean(optional=True), prefix="--write-index", doc=InputDocumentation(doc="Automatically index the output files [off]")), ToolInput(tag="in_verbosity", input_type=Int(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set level of verbosity\n"))], outputs=[ToolOutput(tag="out_output_fmt_option", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_fmt_option", type_hint=File()), doc=OutputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE"))], container="quay.io/biocontainers/samtools:1.11--h6270b1f_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Samtools_Addreplacerg_V0_1_0().translate("wdl")

